

#------------------------------------------------------------------------------
# THIS CODE AND ANY ASSOCIATED INFORMATION ARE PROVIDED AS IS WITHOUT
# WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
# LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS
# FOR A PARTICULAR PURPOSE. THE ENTIRE RISK OF USE, INABILITY TO USE, OR 
# RESULTS FROM THE USE OF THIS CODE REMAINS WITH THE USER.
#
#------------------------------------------------------------------------------
# AUTHOR(s):
# Eyal Doron  
# Hope that you enjoy it ! 
# And, may the force of PowerShell will be with you  :-)
# 05/2015      
# ------------------------------------------------------------------------------



Function Disconnect-ExchangeOnline {Get-PSSession | Where-Object {$_.ConfigurationName -eq "Microsoft.Exchange"} | Remove-PSSession}
Function Validate-UserSelection
{
    Param(
        $AllowedAnswers,
        $ErrorMessage,
        $Selection
    )
    foreach($str in $AllowedAnswers.ToString().Split(","))
    {
        if($str -eq $Selection)
        {
            return $true
        }
    }
    Write-Host $ErrorMessage -ForegroundColor Red -BackgroundColor Black
    return $false

}

function Format-BytesInKiloBytes 
{
    param(
        $bytes
    )
    "{0:N0}" -f ($bytes/1000)
}

Function Set-AlternatingRows {
       <#
       
       #>
    [CmdletBinding()]
       Param(
             [Parameter(Mandatory=$True,ValueFromPipeline=$True)]
        [string]$Line,
       
           [Parameter(Mandatory=$True)]
             [string]$CSSEvenClass,
       
        [Parameter(Mandatory=$True)]
           [string]$CSSOddClass
       )
       Begin {
             $ClassName = $CSSEvenClass
       }
       Process {
             If ($Line.Contains("<tr>"))
             {      $Line = $Line.Replace("<tr>","<tr class=""$ClassName"">")
                    If ($ClassName -eq $CSSEvenClass)
                    {      $ClassName = $CSSOddClass
                    }
                    Else
                    {      $ClassName = $CSSEvenClass
                    }
             }
             Return $Line
       }
}



Function Write-White($Message)
{
    Write-Host  $Message -ForegroundColor White 
}


$FormatEnumerationLimit = -1
$ExportInfo = "The information was exported to the following location C:\INFO"
$settings_array1 = "Received", "SenderAddress","RecipientAddress","Subject","Status", @{Name="size in KB";Expression={Format-BytesInKiloBytes -bytes $_.Size}},"MessageId","FromIP","ToIP"  
$settings_array3 = "Received", "SenderAddress","RecipientAddress","Subject","Status", @{Name="size in KB";Expression={$_.size / 1Kb}},"MessageId", "StartDate","EndDate","FromIP","ToIP" 
$Aarray4 = "DisplayName" , @{Name='Licenses';Expression={$_.Licenses -join ';'}}
#$M70  |Select-Object -Property  $settings_array1 | ConvertTo-Html -Head $Header -Body "<H1>M30 days</H1>"    | Out-File $A20A2\"ALL Messages sent in the last 30 days.html"
$Date = Get-Date

#------------------------------------------------------------------------------
# PowerShell console window Style
#------------------------------------------------------------------------------

$pshost = get-host
$pswindow = $pshost.ui.rawui

	$newsize = $pswindow.buffersize
	
	if($newsize.height){
		$newsize.height = 3000
		$newsize.width = 150
		$pswindow.buffersize = $newsize
	}

	$newsize = $pswindow.windowsize
	if($newsize.height){
		$newsize.height = 50
		$newsize.width = 150
		$pswindow.windowsize = $newsize
	}

#------------------------------------------------------------------------------
# HTML Style start 
#------------------------------------------------------------------------------
$Header = @"
<style>
Body{font-family:segoe ui,arial;color:black; }
H1{ color: white; background-color:#1F4E79; font-weight:bold;width: 70%;margin-top:35px;margin-bottom:25px;font-size: 22px;padding:5px 15px 5px 10px; }
H2{ color: white; background-color:#385643; font-weight:bold;width: 70%;margin-top:35px;margin-bottom:25px;font-size: 22px;padding:5px 15px 5px 10px; }
TABLE {border-width: 1px;border-style: solid;border-color: black;border-collapse: collapse;}
TH {border-width: 1px;padding: 5px;border-style: solid;border-color: #d1d3d4;background-color:#0072c6 ;color:white;}
TD {border-width: 1px;padding: 3px;border-style: solid;border-color: black;}
.odd  { background-color:#ffffff; }
.even { background-color:#dddddd; }
</style>

"@

#------------------------------------------------------------------------------
# HTML Style END
#------------------------------------------------------------------------------

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Search and recover mail items | PowerShell Script menu  
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

$Loop = $true
While ($Loop)
{
    write-host 
    write-host ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    write-host   Search mailbox PowerShell Script menu  
    write-host ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    write-host
    write-host -ForegroundColor green  'Connect PowerShell session to AD Azure and Exchange Online' 
    write-host -ForegroundColor green  '--------------------------------------------------------------' 
    write-host -ForegroundColor Yellow ' 0)   Login in using your Office 365 Administrator credentials' 
    write-host
    write-host
    write-host -ForegroundColor white  -BackgroundColor Blue  ' A: Search + Save a copy (Recover) of Deleted mail items ' 
    write-host -ForegroundColor green  '--------------------------------------------------------------' 
    write-host                                              ' 1)   Search for Deleted mail items in user mailbox and recover (save a copy) of the deleted mail items '
	write-host 
	write-host                                              ' 2)   Search for Deleted mail items in all office 365 mailboxes '
	write-host 
	write-host                                              ' 3)   Search for spesfic type of Deleted mail items (Calendar or Contacts) '
	write-host
    write-host -ForegroundColor white  -BackgroundColor Blue  ' B: Search + Save a copy of mail items with a specific character ' 
    write-host -ForegroundColor green  '--------------------------------------------------------------' 
    write-host                                              ' 4)   Search user mailbox for mail items that include specific word (Text) + save the search results in Destination mailbox '
    write-host
	write-host                                              ' 5)   Search user mailbox for mail items from a spsfic date '
    write-host
	write-host                                              ' 6)   Search for spesfic type of mail items: Calendar or Contacts  '
   	write-host
	write-host                                              ' 7)  Search for spesfic type of mail items: choose the type of the mail item  '
    write-host
	write-host                                              ' 8)  Search for spesfic type of mail items: By mail Size  '
	write-host
    write-host
    write-host -ForegroundColor white  -BackgroundColor Blue  ' C: Mange Exchange Online discovery search mailbox  ' 
    write-host -ForegroundColor green  '--------------------------------------------------------------' 
    write-host
	write-host                                              ' 9)   Assign Full Access Permissions to Discovery Search Mailbox '
	write-host
	write-host                                              ' 10)  Add a user to the Discovery Management role group and Mailbox Import Export role '
	write-host 
	write-host                                              ' 11)  Create a new discovery mailbox + And assign Full Access permission to user '
    
    write-host
    write-host -ForegroundColor green  '--------------------------------------------------------------' 
    write-host
    write-host -ForegroundColor Yellow            "12)  Disconnect PowerShell session" 
    write-host
    write-host -ForegroundColor Yellow            "13)  Exit" 
    write-host

    $opt = Read-Host "Select an option [0-13]"
    write-host $opt
    switch ($opt) 


{


		#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		# Step -00 |  Create a Remote PowerShell session to AD Azure and Exchange Online
		#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


		0
        {

            # Specify your administrative user credentials on the line below 

            $user = Admin@.....

            # This will pop-up a dialogue and request your password
            

            # Import the Local Microsoft Online PowerShell Module Cmdlets and  Establish an Remote PowerShell Session to AD Azure  
            
            Import-Module MSOnline

            

            # Establish an Remote PowerShell Session to Exchange Online 

            $msoExchangeURL = https://outlook.office365.com/powershell-liveid/
			$connected = $false
			$i = 0
			while ( -not ($connected)) {
				$i++
				if($i -eq 4){
					
										
					Write-host
					Write-host -ForegroundColor White	ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
					Write-host
					Write-host -ForegroundColor Red    "Too many incorrect login attempts. Good bye."	
					Write-host
					Write-host -ForegroundColor White	ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
					Write-host
					
					
					exit
				}
				$cred = Get-Credential -Credential $user
				try 
				{
					$session = New-PSSession -ConfigurationName Microsoft.Exchange -ConnectionUri $msoExchangeURL -Credential $cred -Authentication Basic -AllowRedirection  -ErrorAction stop
					Connect-MsolService -Credential $cred -ErrorAction stop
					Import-PSSession $session 
					$connected = $true 
				}
				catch 
				{
					Write-host
					Write-host -ForegroundColor Yellow	ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
					Write-host
					Write-host -ForegroundColor Red     "There is something wrong with the global administrator credentials"	
					Write-host
					Write-host -ForegroundColor Yellow	ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
					Write-host
				}

			}
            
			$host.ui.RawUI.WindowTitle = ("Windows Azure Active Directory |Connected to Office 365 using: " + $Cred.UserName.ToString()  ) 

            


        }




		
		
		#+++++++++++++++++++++++++++++++++++++++++++++++++
		# A: Search + Save a copy (Recover) of Deleted mail items 
		#+++++++++++++++++++++++++++++++++++++++++++++++++

		1
		{

			#######################################################################################################
			#  Search for deleted mail items in user mailbox and recover (save a copy) of the deleted mail items
			#######################################################################################################

			# Section 1: information 

				clear-host

				write-host
				write-host
				write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
				write-host  -ForegroundColor white		Introduction                                                                                          
				write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
				write-host  -ForegroundColor white  	'In the following section we will serach and export deleted mail item from a spesfic mailbox:  '
				write-host  -ForegroundColor white  	'NOTE '
				write-host  -ForegroundColor white  	'The search results (the deleted mail items) will be saved in the Discovery Search Mailbox. '
				write-host  -ForegroundColor white  	'In case that you want to access the Discovery mailbox content by using OWA or Outlook,  '
				write-host  -ForegroundColor white  	'you will need to assign Full Access permission to the user that will access the Discovery mailbox  '
				write-host  -ForegroundColor white  	'this will enbale the user to see (and export to PST if required) the information (the deleted mail items). '
				write-host
				write-host  -ForegroundColor white  	'1. Access discovery mailbox using OWA  '
				write-host  -ForegroundColor white  	'In case that you want the see the content of the discovery mailbox using OWA, you can use  '
				write-host  -ForegroundColor white  	'the following URL: https://outlook.office365.com/owa/<discovery mailbox email> '
				write-host
				write-host  -ForegroundColor white  	'2. Access discovery mailbox using Outlook  '
				write-host  -ForegroundColor white  	'In case that we disable the option of AutoMap, we will need to manually add the Discovery mailbox to the Outlook mail profile  '
				write-host  -ForegroundColor white		--------------------------------------------------------------------------------------  
				write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
				write-host

				# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A]  Search for deleted mail items in user mailbox and recover (save a copy) of the deleted mail items in Discovery mailbox 
				 `n[B]  Search for deleted mail items in user mailbox and recover (save a copy) of the deleted mail items in other mailbox (Destination mailbox)   
				 `n[C]  Search for deleted mail items in user mailbox, create report about deleted mail items and save the LOG in other mailbox (Destination mailbox)
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A, B or C" -Selection $decision -AllowedAnswers "A,B,C"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	'Create search query for deleted mail items of specific user + save data to Discovery mailbox  '
					
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox>  -SearchDumpsterOnly -TargetMailbox "Discovery Search Mailbox" -TargetFolder <Folder> -LogLevel Full  '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
					# Section 2: user input
					
					
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 2 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of the user that you want to search and recover deleted mail items from his mailbox  "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"2. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					
					# Section 3: PowerShell Command
				
					Search-Mailbox $Alias  -SearchDumpsterOnly -TargetMailbox "Discovery Search Mailbox" -TargetFolder $Folder -LogLevel Full 
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
	
				}
	
				if ($decision -eq "B")
				{
				
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchDumpsterOnly -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full  '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
							
					# Section 2: user input
					
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					
					# Section 3: PowerShell Command
					
					Search-Mailbox $Alias  -SearchDumpsterOnly -TargetMailbox $Alias1 -TargetFolder $Folder -LogLevel Full 
					write-host
					write-host


					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
				
						
					# END of B Selection 
				
				}
				
				if ($decision -eq "C")
				{
				
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	'Create search query for deleted mail items of specific user + save LOG File to mailbox that you choose  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source mailbox> -SearchDumpsterOnly -TargetMailbox <Destination mailbox> -TargetFolder <Folder>  -LogOnly  -LogLevel Full  '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
					# Section 2: user input
										
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					# Section 3: PowerShell Command
					

					Search-Mailbox $Alias  -SearchDumpsterOnly -TargetMailbox "$Alias1" -TargetFolder $Folder -LogOnly -LogLevel Full 

					write-host
					write-host


					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
							
						
					# END of C Selection 
				
				}
				
				
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}



		2
		{

			#####################################################################
			#  Search for deleted mail items in all office 365 mailboxes + save data to Discovery mailbox
			#####################################################################

			# Section 1: information 

				clear-host

				write-host
				write-host
				write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
				write-host  -ForegroundColor white		Introduction                                                                                          
				 write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
				write-host  -ForegroundColor white  	'This option will: '
				write-host  -ForegroundColor white  	'Create search query for deleted mail items of ALL of teh Office 365 mailboxes + save data to Discovery mailbox  '
				write-host  -ForegroundColor white  	'NOTE '
				write-host  -ForegroundColor white  	'The search results (the deleted mail items) will be saved in the Discovery Search Mailbox. '
				write-host  -ForegroundColor white  	'In case that you want to access the Discovery mailbox content by using OWA or Outlook,  '
				write-host  -ForegroundColor white  	'you will need to assign Full Access permission to the user that will access the Discovery mailbox  '
				write-host  -ForegroundColor white  	'this will enbale the user to see (and export to PST if required) the information (the deleted mail items). '
				write-host
				write-host  -ForegroundColor white  	'1. Access discovery mailbox using OWA  '
				write-host  -ForegroundColor white  	'In case that you want the see the content of the discovery mailbox using OWA, you can use  '
				write-host  -ForegroundColor white  	'the following URL: https://outlook.office365.com/owa/<discovery mailbox email> '
				write-host
				write-host  -ForegroundColor white  	'2. Access discovery mailbox using Outlook  '
				write-host  -ForegroundColor white  	'In case that we disable the option of AutoMap, we will need to manually add the Discovery mailbox to the Outlook mail profile  '
				write-host  -ForegroundColor white		Information    
				write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
				write-host  -ForegroundColor white  	'In the following section we will Search for deleted mail items in ALL Office 365 mailboxes  '
				write-host  -ForegroundColor white  	'You can choose between two options: '
				write-host  -ForegroundColor white  	'[A] Search for deleted mail items in all office 365 mailboxes and recover (save a copy) of the deleted mail items in Discovery mailbox '
				write-host  -ForegroundColor white  	'[B] Search for deleted mail items in all office 365 mailboxes, create report about deleted mail items and save the LOG in a specific mailbox '
				write-host  -ForegroundColor white		--------------------------------------------------------------------------------------  
				write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
				write-host

				# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A] Search for deleted mail items in all office 365 mailboxes and recover (save a copy) of the deleted mail items in Discovery mailbox 
				 `n[B] Search for deleted mail items in all office 365 mailboxes, create report about deleted mail items and save the LOG in a specific mailbox
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A or B " -Selection $decision -AllowedAnswers "A,B"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: information 
					
					
					write-host
					
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Get-Mailbox -ResultSize Unlimited | Search-Mailbox -SearchDumpsterOnly -TargetMailbox "Discovery Search Mailbox" -TargetFolder <Folder>  -LogLevel Full   '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
					# Section 2: user input
					
					
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 1 parameters:"  
					write-host
					write-host
					write-host -ForegroundColor Yellow	"1. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example: All-users-Delted-mails"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					
					# Section 3: PowerShell Command
				
					
					Get-Mailbox -ResultSize unlimited -Filter {RecipientTypeDetails -eq 'UserMailbox'}  | Search-Mailbox -SearchDumpsterOnly -TargetMailbox "Discovery Search Mailbox" -TargetFolder $Folder -LogLevel Full 
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
	
				}
	
				
				
				if ($decision -eq "B")
				{
				
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	'Create search query for deleted mail items of specific user + save LOG File to mailbox that you choose  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Get-Mailbox -ResultSize unlimited -Filter {RecipientTypeDetails -eq 'UserMailbox'}  | Search-Mailbox -SearchDumpsterOnly -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full -LogOnly   '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
					# Section 2: user input
										
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 2 parameters:"  
					write-host
										
					write-host -ForegroundColor Yellow	"1. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"2. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: All-users-Delted-mails"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host
					# Section 3: PowerShell Command
					

					Get-Mailbox -ResultSize unlimited -Filter {RecipientTypeDetails -eq 'UserMailbox'} | Search-Mailbox -SearchDumpsterOnly -TargetMailbox "$Alias1" -TargetFolder $Folder -LogLevel Full -LogOnly

					write-host
					write-host


					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
							
						
					# END of C Selection 
				
				}
				
			
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}

		
		
		
		
		
		
		3
		{

			#####################################################################
			#  Search for specific type of deleted mail items (Calendar or Contacts)
			#####################################################################

			# Section 1: information 

				clear-host

				write-host
				write-host
				write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
				write-host  -ForegroundColor white		Introduction                                                                                          
				write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
				write-host  -ForegroundColor white  	'In the following section we will Search for specific type of deleted mail items (Calendar or Contacts)  '
				write-host  -ForegroundColor white  	'NOTE '
				write-host  -ForegroundColor white  	'The search results (the Calendar deleted mail items) will be saved in the Destination mailbox. '
				write-host  -ForegroundColor white  	'In case that you want to access the Destination mailbox content by using OWA or Outlook,  '
				write-host  -ForegroundColor white  	'you will need to assign Full Access permission to the user that will access the Destination mailbox '
				write-host  -ForegroundColor white  	'this will enbale the user to see (and export to PST if required) the information (the deleted mail items). '
				write-host
				write-host  -ForegroundColor white  	'1. Access discovery mailbox using OWA  '
				write-host  -ForegroundColor white  	'In case that you want the see the content of the discovery mailbox using OWA, you can use  '
				write-host  -ForegroundColor white  	'the following URL: https://outlook.office365.com/owa/<Destination mailbox email> '
				write-host
				write-host  -ForegroundColor white  	'2. Access Destination mailbox using Outlook  '
				write-host  -ForegroundColor white  	'In case that we disable the option of AutoMap, we will need to manually add the Destination mailbox to the Outlook mail profile  '
				write-host  -ForegroundColor white		--------------------------------------------------------------------------------------  
				write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
				write-host

				# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A] Search for Calendar deleted mail items and save the items in the Destination mailbox. 
				 `n[B] Search for Contacts  deleted mail items and save the items in the Destination mailbox. 
				 
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A,or B " -Selection $decision -AllowedAnswers "A,B"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will search for: '
					write-host  -ForegroundColor white  	'deleted Calendar mail items and save the items in Destination mailbox  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox>  -SearchDumpsterOnly -SearchQuery  "Kind:meetings" -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full    '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
					# Section 2: user input
					
					
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					
					# Section 3: PowerShell Command
				
					
					Search-Mailbox $Alias  -SearchDumpsterOnly -SearchQuery  "Kind:meetings" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full 
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
	
				}
	
				
				
				if ($decision -eq "B")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will search for: '
					write-host  -ForegroundColor white  	'deleted Contacts items and save the items in the Destination mailbox  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox  <Source Mailbox>  -SearchDumpsterOnly -SearchQuery  "Kind:contacts" -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full    '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
					# Section 2: user input
					
					
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					# Section 3: PowerShell Command
				
					
					Search-Mailbox $Alias  -SearchDumpsterOnly -SearchQuery  "Kind:contacts" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full  
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
				
				}
				
				
				
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}

	
		#+++++++++++++++++++++++++++++++++++++++++++++++++
		# B: Search + Save a copy of mail items with a specific character
		#+++++++++++++++++++++++++++++++++++++++++++++++++

		
		
		
		4
		{

			#######################################################################################################
			# Search user mailbox for mail items that include specific word (Text) + save the search results in Destination mailbox
			#######################################################################################################

			# Section 1: information 

				clear-host

				

				# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A]  Search for mail items (and save a copy in the destination mailbox) that includes a specific string (in the mail body, subject etc.). 
				 `n[B]  Search for mail items (and save a copy in the destination mailbox) that includes a specific string in mail subject.
				 `n[C]  Search for mail items (and save a copy in the destination mailbox) that includes a string X or String Y.
				 
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A, B ,or C" -Selection $decision -AllowedAnswers "A,B,C"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	'Search for mail items (and save a copy in the destination mailbox)that includes a specific string (in the mail body, subject etc.)   '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox>  -SearchQuery  <String> -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full   '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 4 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of the user that you want to search his mailbox. "
					write-host
					write-host -ForegroundColor Yellow	"2. String name   "  
					write-host -ForegroundColor Yellow	"The string value (text) that you look for example "
					write-host -ForegroundColor Yellow	"Meeting with Jeff"
					write-host
					$String  = Read-Host "type the string value that you look for"
					write-host
					write-host -ForegroundColor Yellow	"3. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"4. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-mail-items"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host
					
										
					# Section 3: PowerShell Command
				
					Search-Mailbox $Alias  -SearchQuery  "$String" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full 
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
	
				}
	
				if ($decision -eq "B")
				{
				
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	'Search for mail items (and save a copy in the destination mailbox)that includes a specific string in mail subject.  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery 'Subject:"string"'  -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
				
							
					# Section 2: user input
					
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 4 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of the user that you want to search his mailbox. "
					write-host
					write-host -ForegroundColor Yellow	"2. String name   "  
					write-host -ForegroundColor Yellow	"The string value (text) that you look for example "
					write-host -ForegroundColor Yellow	"Meeting with Jeff"
					write-host
					$String  = Read-Host "type the string value that you look for"
					write-host
					write-host -ForegroundColor Yellow	"3. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"4. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-mail-items"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host
					
					
					# Section 3: PowerShell Command
					
					Search-Mailbox $Alias  -SearchQuery Subject:"$String"  -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full 
					write-host
					write-host


					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
				
						
					# END of B Selection 
				
				}
				
				if ($decision -eq "C")
				{
				
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	'Search for mail items (and save a copy in the destination mailbox)that includes a string X or String Y.  '
					write-host  -ForegroundColor white  	'for example, mail items that incloudes the string "home" or "test"  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery -SearchQuery '"String" or "String1"'  -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
				
							
					# Section 2: user input
					
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 4 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of the user that you want to search his mailbox. "
					write-host
					write-host -ForegroundColor Yellow	"2. String name   "  
					write-host -ForegroundColor Yellow	"The string value (text) that you look for example "
					write-host -ForegroundColor Yellow	"Meeting with Jeff"
					write-host
					$String  = Read-Host "type the string value that you look for"
					write-host
					write-host
					write-host -ForegroundColor Yellow	"3. String name   "  
					write-host -ForegroundColor Yellow	"The string value (text) that you look for example "
					write-host -ForegroundColor Yellow	"Meeting with John"
					write-host
					$String  = Read-Host "type the string value that you look for"
					write-host
					write-host -ForegroundColor Yellow	"4. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host
					write-host -ForegroundColor Yellow	"5. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-mail-items"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host
					
					# Section 3: PowerShell Command
					
					Search-Mailbox $Alias  -SearchQuery '"$String" OR "$String1" ' -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full 
					write-host
					write-host


					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
				
						
					# END of B Selection 
					# END of C Selection 
				
				}
				
				
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}


		
		
		
		5
		{

			#######################################################################################################
			#  Search user mailbox for mail items from a specific date
			#######################################################################################################

			# Section 1: information 

				clear-host


				# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A]  Search user mailbox for mail items from a specific date
				 `n[B]  Search user mailbox for mail items from a specific date range
				  " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A, B or C" -Selection $decision -AllowedAnswers "A,B,C"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	'Search user mailbox for mail items from a specific date   '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery sent:dd/mm/yy -TargetMailbox <Destination mailbox> -TargetFolder <Folder> -LogLevel Full   '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 4 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host -ForegroundColor Yellow	"4. Specific date   "  
					write-host -ForegroundColor Yellow	"Type the date using the following format dd/mm/yy "
					write-host -ForegroundColor Yellow	"For example: 09/18/2015"
					write-host
					$Date  = Read-Host "type the date"
					write-host
																				
					# Section 3: PowerShell Command
				
					Search-Mailbox "$Alias" -SearchQuery sent:"$date" -TargetMailbox "$Alias1" -TargetFolder "$Folder"
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
	
				}
	
				if ($decision -eq "B")
				{
				
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will: '
					write-host  -ForegroundColor white  	' Search user mailbox for mail items from a specific date range.  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					#write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery '(sent:dd/mm/yy..dd/mm/yy) '  -TargetMailbox <Destination mailbox> -TargetFolder <Folder name> '
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery sent:"<StartDate>..<StartDate>"  -TargetMailbox <Destination mailbox> -TargetFolder <Folder name> '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
				
							
					
					
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 5 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host -ForegroundColor Yellow	"4. Start date   "  
					write-host -ForegroundColor Yellow	"Type the date using the following format dd/mm/yy "
					write-host -ForegroundColor Yellow	"For example: 09/1/2015"
					write-host
					$SDate  = Read-Host "type the date"
					write-host
					write-host -ForegroundColor Yellow	"5. End date   "  
					write-host -ForegroundColor Yellow	"Type the date using the following format dd/mm/yy "
					write-host -ForegroundColor Yellow	"For example: 09/18/2015"
					write-host
					$EDate  = Read-Host "type the date"
					write-host
					# Section 3: PowerShell Command
					
					Search-Mailbox "$Alias" -SearchQuery sent:"$Sdate..$Edate"  -TargetMailbox "$Alias1" -TargetFolder "$Folder"
					write-host
					write-host


					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
				
						
					# END of B Selection 
				
				}
				
														
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}

		
		
		
		6
		{

			#####################################################################
			#  Search for specific type of mail items (Calendar or Contacts)
			#####################################################################

			# Section 1: information 

				clear-host

				write-host
				

				# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A] Search for Calendar mail items and save the items in the Destination mailbox. 
				 `n[B] Search for Contacts mail items and save the items in the Destination mailbox.
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A or B " -Selection $decision -AllowedAnswers "A,B"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will search for: '
					write-host  -ForegroundColor white  	'Calendar deleted mail items and save the items in Destination mailbox  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery  "Kind:meetings" -TargetMailbox <Destination mailbox>  -TargetFolder $Folder -LogLevel Full    '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
				
					
					
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					
					# Section 3: PowerShell Command
				
					
					Search-Mailbox $Alias  -SearchQuery  "Kind:meetings" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full 
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
	
				}
	
				
				
				if ($decision -eq "B")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will search for: '
					write-host  -ForegroundColor white  	'Contacts items and save the items in the Destination mailbox  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery  "Kind:contacts" -TargetMailbox <Destination mailbox>  -TargetFolder $Folder -LogLevel Full    '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					
					# Section 3: PowerShell Command
				
					
					Search-Mailbox "$Alias"  -SearchQuery  "Kind:contacts" -TargetMailbox "$Alias1"  -TargetFolder "$Folder" -LogLevel Full  
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
				
				}
				
										
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}

		
		
		
		
		7
		{

			#####################################################################
			#  Search for specific type of mail items (Calendar or Contacts)
			#####################################################################

			# Section 1: information 

				

				# Section 0: decision 

				
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will search for: '
					write-host  -ForegroundColor white  	'Search for a specific type of mail items and save a copy on a destination mailbox   '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox>  -SearchQuery  "Kind:<Type>" -TargetMailbox <Destination mailbox>  -TargetFolder <Folder> -LogLevel Full   '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
					
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 4 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search and recover deleted mail items from his mailbox  "  
					write-host -ForegroundColor Yellow	"NOTE - You can use the user Alias as Identity or the user Email address "
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of user search and recover deleted mail items from his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-Delted-mail"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host -ForegroundColor Yellow	"4. Mail item type   "  
					write-host -ForegroundColor Yellow	"The Mail item type that you look for "
					write-host -ForegroundColor Yellow	"you can choose one of this options: contacts,email,tasks,meetings,notes,docs,text,spreadsheets,presentations,music,pics,videos,folders"
					write-host -ForegroundColor Yellow	"For example: notes"
					write-host
					$MItem  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					write-host
					
					
					# Section 3: PowerShell Command
				
					#$mbitem = $MailBox+":\calendar"
					$mbitem = "kind"+$MItem
					
					
					#Search-Mailbox $Alias  -SearchQuery  "Kind:$MItem" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full
					#Search-Mailbox $Alias  -SearchQuery  "Kind:'$MItem'" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full
					Search-Mailbox $Alias  -SearchQuery  "$mbitem" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full  	  					
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
				
				

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}

		
		
		
		
		
		
		
		8
		{

			#####################################################################
			#  Search for specific type of mail items by size
			#####################################################################

			# Section 1: information 

				clear-host

				

				# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A] Search for mail items by size and estimate only in the Destination mailbox. 
				 `n[B] Search for mail items by size and save the items in the Destination mailbox.
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A or B " -Selection $decision -AllowedAnswers "A,B"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will search for: '
					write-host  -ForegroundColor white  	'Search for mail items that their size is more then 5MB  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox>  -SearchQuery  "Size:>5MB" -TargetMailbox <Destination mailbox>  -TargetFolder <folder> -LogLevel Full -estimateonly    '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
									
					
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search his mailbox  "  
					write-host -ForegroundColor Yellow	"for mail items that their size is more then 5MB  "  
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of the user that you want to search his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-mail_More_5MB"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					
					# Section 3: PowerShell Command
				
							
					Search-Mailbox $Alias  -SearchQuery  "Size:>5MB" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full -estimateonly
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
	
				}
	
				
				
				if ($decision -eq "B")
				{
				
					# Section 1: information 
					
					
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
					write-host  -ForegroundColor white		Information                                                                                          
					write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
					write-host  -ForegroundColor white  	'This option will search for: '
					write-host  -ForegroundColor white  	'Contacts items and save the items in the Destination mailbox  '
					write-host  -ForegroundColor white		----------------------------------------------------------------------------  
					write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
					write-host
					write-host  -ForegroundColor Yellow  	'Search-Mailbox <Source Mailbox> -SearchQuery  "Kind:contacts" -TargetMailbox <Destination mailbox>  -TargetFolder <Folder> -LogLevel Full    '
					write-host
					write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
					write-host
					write-host
					write-host
	
						
					# Section 2: user input
					write-host -ForegroundColor white	'User input '
					write-host -ForegroundColor white	---------------------------------------------------------------------------- 
					write-host -ForegroundColor Yellow	"You will need to provide 3 parameters:"  
					write-host
					write-host -ForegroundColor Yellow	"1. Identity of the user that you want to search his mailbox  "  
					write-host -ForegroundColor Yellow	"for mail items that their size is more then 5MB  "  
					write-host -ForegroundColor Yellow	"For example:  John@o365info.com"
					write-host
					$Alias  = Read-Host "Type the Identity of the user that you want to search his mailbox "
					write-host
					write-host -ForegroundColor Yellow	"2. Identity of Destination mailbox  "  
					write-host -ForegroundColor Yellow	"The mailbox that will serve as a container for the copy of the mail items "
					write-host -ForegroundColor Yellow	"For example:  admin@o365info.com"
					write-host
					$Alias1  = Read-Host "Type the Identity of the Destination mailbox "
					write-host
					write-host -ForegroundColor Yellow	"3. Folder name   "  
					write-host -ForegroundColor Yellow	"The Folder name that you provide will be created at the destination mailbox and contain the Log file "
					write-host -ForegroundColor Yellow	"For example: John-mail_More_5MB"
					write-host
					$Folder  = Read-Host "Folder name that you provide will be created at the destination mailbox and contain the search result"
					write-host
					
					# Section 3: PowerShell Command
				
					
					Search-Mailbox $Alias  -SearchQuery  "Size:>5MB" -TargetMailbox $Alias1  -TargetFolder $Folder -LogLevel Full 
					
					write-host
					write-host

					#Section 5: End the Command
					write-host
					write-host
					Read-Host "Press Enter to continue..."
					write-host
					write-host
	
					# END of A Selection 
				
				}
				
										
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				#Section 5: End the Command
				write-host
				write-host
				Read-Host "Press Enter to continue..."
				write-host
				write-host

		}

		
		
		
		#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		# Mange Exchange Online discovery search mailbox 
		#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		
		
		
		9{

			#####################################################################
			#  Add Full access permission to the discovery search mailbox
			#####################################################################

			# Section 1: information 

			clear-host

			write-host
			write-host
			write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
			write-host  -ForegroundColor white		Information                                                                                          
			write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
			write-host  -ForegroundColor white  	'This option will: '
			write-host  -ForegroundColor white  	'Assign FULL Access Permissions for the Discovery Search Mailbox. '
			write-host  -ForegroundColor white  	'The search results (the deleted mail items) will be saved in the Discovery Search Mailbox. '
			write-host  -ForegroundColor white  	'In case that you want to access the Discovery mailbox content by using OWA or Outlook,  '
			write-host  -ForegroundColor white  	'you will need to assign Full Access permission to the user that will access the Discovery mailbox  '
			write-host  -ForegroundColor white  	'this will enbale the user to see (and export to PST if required) the information (the deleted mail items). '
			write-host
			write-host  -ForegroundColor white  	'1. Access discovery mailbox using OWA  '
			write-host  -ForegroundColor white  	'In case that you want the see the content of the discovery mailbox using OWA, you can use  '
			write-host  -ForegroundColor white  	'the following URL: https://outlook.office365.com/owa/<discovery mailbox email> '
			write-host
			write-host  -ForegroundColor white  	'2. Access discovery mailbox using Outlook  '
			write-host  -ForegroundColor white  	'In case that we disable the option of AutoMap, we will need to manually add the Discovery mailbox to the Outlook mail profile  '
			write-host  -ForegroundColor white		----------------------------------------------------------------------------  
			write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
			write-host
			write-host  -ForegroundColor Yellow  	'Add-MailboxPermission "Discovery Search Mailbox"  -User <Identity> -AccessRights FullAccess -InheritanceType all -Automapping $false  '
			write-host
			write-host
			write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
			write-host
			write-host
			write-host
			write-host
			# Section 2: user input	
			write-host -ForegroundColor white	'User input '
			write-host -ForegroundColor white	---------------------------------------------------------------------------- 
			write-host -ForegroundColor Yellow	"You will need to provide 1 parameter:"  
			write-host
			write-host -ForegroundColor Yellow	"1. Mailbox name of user that you will be assigned with Full access permission   "  
			write-host -ForegroundColor Yellow	"For example:  Alice@o365info.com "
			$Alias  = Read-Host "Type the Mailbox name of user that you want to assign Full Access permission "
			write-host
			write-host


			Add-MailboxPermission "Discovery Search Mailbox"  -User $Alias -AccessRights FullAccess -InheritanceType all -Automapping $False

			
			#Section 3: Display Information

			write-host ------------------------------------------------------------------------
			write-host -ForegroundColor white  -BackgroundColor Blue	"List of Users That have FULL ACCESS permissions for Discovery Search Mailbox " 
			write-host ------------------------------------------------------------------------
			write-host 
			Get-Mailboxpermission "Discovery Search Mailbox" | Where { ($_.IsInherited -eq $false) -and -not ($_.User -like NT AUTHORITY\SELF) } | Select Identity,  @{name="User";expression={(Get-User $_.User).Name}},AccessRights  | Out-String
			write-host 	
			write-host ------------------------------------------------------------------------
			write-host
			write-host
			
			
			#Section 5: End the Command
			write-host
			write-host
			Read-Host "Press Enter to continue..."
			write-host
			write-host

			}

		
			10{

			#####################################################################
			#  Add a user to the Discovery Management role group and Mailbox Import Export role 
			#####################################################################

			# Section 1: information 

			clear-host

			write-host
			write-host
			write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
			write-host  -ForegroundColor white		Information                                                                                          
			write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
			write-host  -ForegroundColor white  	'This option will: '
			write-host  -ForegroundColor white  	'Add the required permission for a user for using the option of in-place eDiscovery & hold  '
			write-host  -ForegroundColor white  	'option ( based on the PowerShell command New-MailboxSearch ) and the option for using  '
			write-host  -ForegroundColor white  	'the PowerShell command Search-Mailbox that enable us to recover a specific mail items for  '
			write-host  -ForegroundColor white  	'the recovery mail folder( deleted mail items) '
			write-host  -ForegroundColor white  	'By default, the Discovery Management role and the Mailbox Import Export role isnt assigned to any role group.  '
			write-host  -ForegroundColor white  	'NOTE-  the assignment of the permission could take up to 15 minutes '
			write-host  -ForegroundColor white  	'NOTE-  other option is to add the Mailbox Import Export role to the Organization Management role group  '
			write-host  -ForegroundColor white		----------------------------------------------------------------------------  
			write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
			write-host
			write-host  -ForegroundColor Yellow  	'Add-RoleGroupMember -Identity "Discovery Management" -Member <Identity>  '
			write-host
			write-host  -ForegroundColor Yellow  	'New-ManagementRoleAssignment Role Mailbox Import Export User <Identity>  '
			write-host
			write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
			write-host
			write-host
			write-host
			write-host

			write-host
			write-host -ForegroundColor Yellow	"Type the user name that you want to add to the Discovery Management role group " 

			write-host -ForegroundColor Yellow	"For example: Admin"
			write-host
			$Alias = Read-Host "Type the user name that you want to add to the Discovery Management role group  "
			write-host


			Add-RoleGroupMember -Identity "Discovery Management" -Member  $Alias
			New-ManagementRoleAssignment Role Mailbox Import Export User $Alias

			#Section 5: End the Command
			write-host
			write-host
			Read-Host "Press Enter to continue..."
			write-host
			write-host

			}

			11{

			#####################################################################
			# Create a new search mailbox and Assign FULL Access Permissions for the Discovery Search Mailbox
			#####################################################################

			# Section 1: information 

			clear-host

			write-host
			write-host
			write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                         
			write-host  -ForegroundColor white		Information                                                                                          
			write-host  -ForegroundColor white		----------------------------------------------------------------------------                                                             
			write-host  -ForegroundColor white  	'This option will: '
			write-host  -ForegroundColor white  	'Create a new search mailbox  '
			write-host  -ForegroundColor white  	'Assign FULL Access Permissions for the Discovery Search Mailbox. '
			write-host  -ForegroundColor white		----------------------------------------------------------------------------  
			write-host  -ForegroundColor white  	'The PowerShell command that we use is: '
			write-host
			write-host  -ForegroundColor Yellow  	'Add-MailboxPermission "Discovery Search Mailbox"  -User <Identity> -AccessRights FullAccess -InheritanceType all -Automapping $false  '
			write-host
			write-host
			write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
			write-host
			write-host
			write-host
			write-host
			# Section 2: user input	
			write-host -ForegroundColor white	'User input '
			write-host -ForegroundColor white	---------------------------------------------------------------------------- 
			write-host -ForegroundColor Yellow	"You will need to provide 2 parameters:"  
			
			write-host
			write-host -ForegroundColor Yellow	"1. New search mailbox name    " 
			write-host
			write-host -ForegroundColor Yellow	"Type the name of the new search mailbox " 

			write-host -ForegroundColor Yellow	"For example: discovery01"
			write-host
			$Alias = Read-Host "Type the name of the new search mailbox  "
			write-host



			# Section 3: PowerShell Command


			New-Mailbox -Name $Alias -Discovery

			write-host
			write-host



			write-host
			write-host
			write-host  -ForegroundColor white		----------------------------------------------------------------------------  
			write-host  -ForegroundColor white  	Display information about all discovery Mailboxes 
			write-host  -ForegroundColor white		----------------------------------------------------------------------------
			write-host
			write-host

			Get-Mailbox -Resultsize unlimited -Filter {RecipientTypeDetails -eq "DiscoveryMailbox"} | out-string

			write-host
			write-host
			write-host  -ForegroundColor white		----------------------------------------------------------------------------  

			
			
			write-host
			write-host -ForegroundColor Yellow	"2. Mailbox name of user that you will be assigned with Full access permission   "  
			write-host -ForegroundColor Yellow	"For example:  Alice@o365info.com "
			$Alias1  = Read-Host "Type the Mailbox name of user that you want to assign Full Access permission "
			write-host
			write-host


			Add-MailboxPermission "$Alias"  -User "$Alias1" -AccessRights FullAccess -InheritanceType all -Automapping $false

			
			#Section 3: Display Information

			write-host ------------------------------------------------------------------------
			write-host -ForegroundColor white  -BackgroundColor Blue	"List of Users That have FULL ACCESS permissions for $Alias MailBox " 
			write-host ------------------------------------------------------------------------
			write-host 
			Get-Mailboxpermission $Alias | where { ($_.IsInherited -eq $false) -and -not ($_.User -like NT AUTHORITY\SELF) } |Select Identity,  @{name="User";expression={(Get-User $_.User).Name}},AccessRights  | Out-String
			write-host 	
			write-host ------------------------------------------------------------------------
			write-host
			write-host
			
			
			#Section 5: End the Command
			write-host
			write-host
			Read-Host "Press Enter to continue..."
			write-host
			write-host

			}



 
 
#+++++++++++++++++++
# Step -05 Finish  
##++++++++++++++++++
 
 
12{

##########################################
# Disconnect PowerShell session  
##########################################


write-host -ForegroundColor Yellow Choosing this option will Disconnect the current PowerShell session 

Function Disconnect-ExchangeOnline {Get-PSSession | Where-Object {$_.ConfigurationName -eq "Microsoft.Exchange"} | Remove-PSSession}
Disconnect-ExchangeOnline -confirm

write-host
write-host

# Indication 

if ($lastexitcode -eq 0)
{
	write-host -------------------------------------------------------------
	write-host "The command complete successfully !" -ForegroundColor Yellow
	write-host "The PowerShell session is disconnected" -ForegroundColor Yellow
    write-host -------------------------------------------------------------
}
else

{
	write-host "The command Failed :-(" -ForegroundColor red
	
}

# End of Indication 


}




13{

##########################################
# Exit  
##########################################


$Loop = $true
Exit
}

}


}
